#!/usr/bin/env python

__author__ = "Artur Duque de Souza"
__author_email__ = "artur.souza@indt.org.br"
__license__ = "GPL"
__version__ = "0.1"

import os
import pickle
import lib.utils as utils

from stat import *

__all__ = ("FileList", "list_media_files")


class TranscodedFile(object):
    """This class creates and reads information about transcoded files."""
    opts = {}

    def __init__(self, filename, args):
        print filename
        if filename == "" or not os.path.exists(filename):
            self.opts = args.copy()
            self.opts["original"] = self.opts.pop("input", "").split("://")[1]
            self.opts["original_mtime"] = os.stat(
                self.opts["original"])[ST_MTIME]

            name = os.path.splitext(os.path.basename(self.opts["outfile"]))[0]
            output = open(".transcoded/%s.dat" % name, "wb")
            # dumps data using the highest protocol
            pickle.dump(self.opts, output, -1)
            output.close()
        else:
            name = os.path.splitext(os.path.basename(filename))[0]
            pkl_file = open(".transcoded/%s.dat" % name, "rb")
            self.opts = pickle.load(pkl_file)
    # __init__()

# TranscodedFile


class FileList(list):
    """Class to hold file's list - reimplements str and repr."""
    def __str__(self):
        ret = ""
        if len(self) > 0:
            for item in self:
                ret = ret + " %s" % item
        return ret
    # __str__()

    def __repr__(self):
        return self.__str__()
    # __repr__()

# FileList

def list_media_files(directory, file_list):
    """Show all the media files with extension defined in the var 'ext'
    that are in the directory, appending each one to 'file_list'."""
    ext = ['mpg', 'avi', 'mp4', 'nuv', 'mpeg', 'mov']
    for root, dirs, files in os.walk(directory):
        for name in files:
            if os.path.splitext(name)[1].strip(".") in ext:
                dat_file = os.path.join(root,name.split(".")[0]+".dat")
                if name not in file_list and os.path.exists(dat_file):
                    file_list.append(name)

    return True
# list_media_files()
